%define 	pname httpd
%define 	pversion 2.2.20
%define 	bversion 100
%define 	rpmrelease iworx
%define 	contentdir /var/www
%define 	suexec_caller apache
%define 	suexec_dir /home
%define 	mmn 20051115
%define		apr_version 1.2.7

%define 	debug_package %{nil}

# INSTRUCTIONS!!! <--------------------- READ THEM!!!
#
# You can rebuild  this  package safely using Command 
# Line Overrides. For example, if you want to rebuild
# this package for RedHat just type:
# $ rpm --rebuild --with redhat package.src.rpm
# $ rpm -ba --with redhat package.spec
#
# mdk = GNU/Linux Mandrake
# rht = Linux Red-Hat
# sus = Suse Linux
# fdr = Fedora Linux
# cos = CentOS
# whb = White Box Linux
# rhe = Red Hat Enterprise
# unk = Unknown
#

%define 	build_rht_90   0
%define		build_cos_3x   0
%define		build_fdr_10   0
%define		build_fdr_20   0
%define		build_fdr_30   0
%define		build_fdr_40   0
%define		build_fdr_80   0
%define		build_fdr_90   0
%define		build_whb_3x   0
%define		build_rhe_2x   0
%define		build_rhe_3x   0
%define		build_rhe_4x   0
%define		build_rhe_5x   0
%define		build_rhe_6x   0

%define		build_unk      1

# Command Line Overrides
%{?_with_rht90:   	%{expand: %%define build_rht_90   1}}
%{?_with_cos3x: 	%{expand: %%define build_cos_3x   1}}
%{?_with_fdr10: 	%{expand: %%define build_fdr_10   1}}
%{?_with_fdr20: 	%{expand: %%define build_fdr_20   1}}
%{?_with_fdr30: 	%{expand: %%define build_fdr_30   1}}
%{?_with_fdr40: 	%{expand: %%define build_fdr_40   1}}
%{?_with_fdr80: 	%{expand: %%define build_fdr_80   1}}
%{?_with_fdr90: 	%{expand: %%define build_fdr_90   1}}
%{?_with_whb3x: 	%{expand: %%define build_whb_3x   1}}
%{?_with_rhe2x: 	%{expand: %%define build_rhe_2x   1}}
%{?_with_rhe3x: 	%{expand: %%define build_rhe_3x   1}}
%{?_with_rhe4x: 	%{expand: %%define build_rhe_4x   1}}
%{?_with_rhe5x: 	%{expand: %%define build_rhe_5x   1}}
%{?_with_rhe6x: 	%{expand: %%define build_rhe_6x   1}}

%{?_with_unk: 		%{expand: %%define build_unk      1}}

# Distro Statements
%if %{build_rht_90}
%define		oscode rht90
%define 	ostype RedHat 9
BuildRequires:	pcre-devel
BuildRequires:  db4-devel
BuildRequires:	expat-devel
BuildRequires:	findutils
BuildRequires:	perl
BuildRequires:	pkgconfig
Requires: 	sh-utils
Requires:	textutils
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_cos_3x}
%define		oscode cos3x
%define 	ostype CentOS 3.x
BuildRequires:	pcre-devel
BuildRequires:  db4-devel
BuildRequires:	expat-devel
BuildRequires:	findutils
BuildRequires:	perl
BuildRequires:	pkgconfig
Requires: 	sh-utils
Requires:	textutils
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_10}
%define		oscode fdr10
%define 	ostype Fedora Core 1
BuildRequires:	pcre-devel
BuildRequires:  db4-devel
BuildRequires:	expat-devel
BuildRequires:	findutils
BuildRequires:	perl
BuildRequires:	pkgconfig
Requires: 	sh-utils
Requires:	textutils
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_20}
%define		oscode fdr20
%define 	ostype Fedora Core 2
BuildRequires:	pcre-devel
BuildRequires:  db4-devel
BuildRequires:	expat-devel
BuildRequires:	findutils
BuildRequires:	perl
BuildRequires:	pkgconfig
Requires: 	sh-utils
Requires:	textutils
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_30}
%define		oscode fdr30
%define 	ostype Fedora Core 3
BuildRequires:	pcre-devel
BuildRequires:  db4-devel
BuildRequires:	expat-devel
BuildRequires:	findutils
BuildRequires:	perl
BuildRequires:	pkgconfig
Requires: 	sh-utils
Requires:	textutils
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_40}
%define		oscode fdr40
%define 	ostype Fedora Core 4
BuildRequires:	pcre-devel
BuildRequires:  db4-devel
BuildRequires:	expat-devel
BuildRequires:	findutils
BuildRequires:	perl
BuildRequires:	pkgconfig
Requires: 	sh-utils
Requires:	textutils
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_80}
%define		oscode fdr80
%define 	ostype Fedora Core 8
BuildRequires:	pcre-devel
BuildRequires:  db4-devel
BuildRequires:	expat-devel
BuildRequires:	findutils
BuildRequires:	perl
BuildRequires:	pkgconfig
Requires: 	sh-utils
Requires:	textutils
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_90}
%define		oscode fdr90
%define 	ostype Fedora Core 9
BuildRequires:	pcre-devel
BuildRequires:  db4-devel
BuildRequires:	expat-devel
BuildRequires:	findutils
BuildRequires:	perl
BuildRequires:	pkgconfig
BuildRequires:	libtool
Requires: 	sh-utils
Requires:	textutils
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_whb_3x}
%define		oscode whb3x
%define 	ostype White Box 3.x
BuildRequires:	pcre-devel
BuildRequires:  db4-devel
BuildRequires:	expat-devel
BuildRequires:	findutils
BuildRequires:	perl
BuildRequires:	pkgconfig
Requires: 	sh-utils
Requires:	textutils
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_2x}
%define		oscode rhe2x
%define 	ostype RedHat Enterprise 2.x
BuildRequires:	pcre-devel
BuildRequires:  db4-devel
BuildRequires:	expat-devel
BuildRequires:	findutils
BuildRequires:	perl
BuildRequires:	pkgconfig
Requires: 	sh-utils
Requires:	textutils
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_3x}
%define		oscode rhe3x
%define 	ostype RedHat Enterprise 3.x
BuildRequires:	pcre-devel
BuildRequires:  db4-devel
BuildRequires:	expat-devel
BuildRequires:	findutils
BuildRequires:	perl
BuildRequires:	pkgconfig
Requires: 	sh-utils
Requires:	textutils
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_4x}
%define		oscode rhe4x
%define 	ostype RedHat Enterprise 4.x
BuildRequires:	pcre-devel
BuildRequires:  db4-devel
BuildRequires:	expat-devel
BuildRequires:	findutils
BuildRequires:	perl
BuildRequires:	pkgconfig
Requires: 	sh-utils
Requires:	textutils
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_5x}
%define		oscode rhe5x
%define 	ostype RedHat Enterprise 5.x
BuildRequires:	pcre-devel
BuildRequires:  db4-devel
BuildRequires:	expat-devel
BuildRequires:	findutils
BuildRequires:	perl
BuildRequires:	pkgconfig
BuildRequires:	autoconf
BuildRequires:	libtool
Requires: 	sh-utils
Requires:	textutils
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_6x}
%define		oscode rhe6x
%define 	ostype RedHat Enterprise 6.x
BuildRequires:	pcre-devel
BuildRequires:  db4-devel
BuildRequires:	expat-devel
BuildRequires:	findutils
BuildRequires:	perl
BuildRequires:	pkgconfig
BuildRequires:	autoconf
BuildRequires:	libtool
Requires: 	sh-utils
Requires:	textutils
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%define	release %{bversion}.%{oscode}.%{rpmrelease}

##
# THIS MUST BE LAST
##

%if %{build_unk}
%define		oscode unk
%define		release %{bversion}.%{rpmrelease}
%define 	ostype Unknown Distribution
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%endif

############### RPM ################################

Summary: 	Apache HTTP Server
Name: 		%{pname}
Version: 	%{pversion}
Release: 	%{release}
License: 	Apache License, Version 2.0

Group: 		System Environment/Daemons
Source0:	%{name}-%{version}.tar.gz
URL: 		http://httpd.apache.org/

Distribution:	InterWorx-HAL
Vendor:         NEXCESS.NET L.L.C
Packager:	Chris Wells <clwells@nexcess.net>

BuildRoot:	%{_tmppath}/%{name}-%{version}-root

BuildRequires:	apr-devel      >= %{apr_version}
BuildRequires:	apr-util-devel >= %{apr_version}
BuildRequires:	autoconf
BuildRequires:	libtool
BuildRequires:	openldap-devel
BuildRequires:  python
Requires:	apr            >= %{apr_version}
Requires:	apr-util       >= %{apr_version}

Requires:	shadow-utils
Requires:	initscripts
Requires:	chkconfig
Requires: 	net-tools

Conflicts:      thttpd

Obsoletes:      apache
Obsoletes:	secureweb
Obsoletes:	mod_dav
Obsoletes:	httpd-suexec

Provides: 	webserver
Provides: 	httpd-mmn = %{mmn}

Source2:	httpd-ssl.conf
Source3:	httpd.init
Source4:	httpd-index.php
Source5:	httpd-apache_pb.gif
Source6:	httpd-iworx_pb.gif
Source7:	httpd-openssl_pb.gif
Source8:	httpd-php_pb.png
Source9:	httpd-interworx_logo.gif

Source10:	httpd.conf.i386
Source11:	httpd.conf.x86_64

#Patch0:  	httpd-2.0.36-apxs.patch
Patch1:		fdsetsize4096.patch

%description
Apache is a powerful, full-featured, efficient, and freely-available
Web server. Apache is also the most popular Web server on the
Internet.

%package devel
Group: 		Development/Libraries
Summary: 	Development tools for the Apache HTTP server.
Obsoletes: 	secureweb-devel, apache-devel
Requires: 	libtool
Requires:	httpd = %{version}

%description devel
The httpd-devel package contains the APXS binary and other files
that you need to build Dynamic Shared Objects (DSOs) for Apache.

If you are installing the Apache HTTP server and you want to be
ble to compile or develop additional modules for Apache, you need
to install this package.

%package manual
Group: 		Documentation
Summary: 	Documentation for the Apache HTTP server.
Obsoletes: 	secureweb-manual, apache-manual

%description manual
The httpd-manual package contains the complete manual and
reference guide for the Apache HTTP server. The information can
also be found at http://httpd.apache.org/docs/.

%package -n mod_ssl
Group: 		System Environment/Daemons
Summary: 	SSL/TLS module for the Apache HTTP server
BuildRequires: 	openssl-devel
BuildRequires:	openssl, dev, /bin/cat
Requires: 	httpd
Requires:	make
Requires:	httpd-mmn = %{mmn}

## THIS IS NEEDED FOR GODDAMN CENTOS 4 WHICH THOUGHT IT
## AS A GOOD IDEA TO BUMP THEIR SERIAL # ONLY ON MOD_SSL
Epoch:		1

%description -n mod_ssl
The mod_ssl module provides strong cryptography for the Apache Web
server via the Secure Sockets Layer (SSL) and Transport Layer
Security (TLS) protocols.

%prep

%setup -q
#%patch0 -p1 -b .apxs
%patch1 -p1

# Safety check: prevent build if defined MMN does not equal upstream MMN.
vmmn=`echo MODULE_MAGIC_NUMBER_MAJOR | cpp -include \`pwd\`/include/ap_mmn.h | grep -e '^[0-9]'`
if test x${vmmn} != x%{mmn}; then
   : Error: Upstream MMN is now ${vmmn}, packaged MMN is %{mmn}.
   : Update the mmn macro and rebuild.
   exit 1
fi

# Try detecting newest gcc (some distributions have got more then one compiler)
[ -f %{_tmppath}/%{name}-%{pversion}-gcc ] && rm -f %{_tmppath}/%{name}-%{pversion}-gcc

if   [ -x /usr/bin/gcc-3.2.3 ]; then
	echo "/usr/bin/gcc-3.2.3" > %{_tmppath}/%{name}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.2 ]; then
	echo "/usr/bin/gcc-3.2.2" > %{_tmppath}/%{name}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.1 ]; then
	echo "/usr/bin/gcc-3.2.1" > %{_tmppath}/%{name}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.2 ]; then
        echo "/usr/bin/gcc-3.2" > %{_tmppath}/%{name}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.1.1 ]; then
        echo "/usr/bin/gcc-3.1.1" > %{_tmppath}/%{name}-%{pversion}-gcc
else
	echo "gcc" > %{_tmppath}/%{name}-%{pversion}-gcc
fi

# Display compilation flags and OS with nice colors
[ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{name}-%{pversion}-show_flags
cat <<EOF >>%{_tmppath}/%{name}-%{pversion}-show_flags
#!/bin/sh

RPM="RPM RELEASE: \033[40m\033[001;033m%{release}"
OS="OS TYPE IS : \033[40m\033[001;033m%{ostype}"
GCC="GCC IS     : \033[40m\033[001;033m`cat %{_tmppath}/%{name}-%{pversion}-gcc`"
CCF="CCFLAGS    : \033[40m\033[001;033m%{ccflags}"
LDF="LDFLAGS    : \033[40m\033[001;033m%{ldflags}"

echo
echo
echo -e "\033[40m\033[001;031m\$RPM\033[0m"
echo -e "\033[40m\033[001;031m\$OS\033[0m"
echo -e "\033[40m\033[001;031m\$GCC\033[0m"
echo -e "\033[40m\033[001;031m\$CCF\033[0m"
echo -e "\033[40m\033[001;031m\$LDF\033[0m"
echo
echo

sleep 3

EOF

# Take care to execute and then to delete
chmod u+x %{_tmppath}/%{name}-%{pversion}-show_flags
%{_tmppath}/%{name}-%{pversion}-show_flags
[ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{name}-%{pversion}-show_flags

# regenerate configure scripts
./buildconf

# Before configure; fix location of build dir in generated apxs
%{__perl} -pi -e "s:\@exp_installbuilddir\@:%{_libdir}/httpd/build:g" \
	support/apxs.in

%build

if pkg-config openssl ; then
	# configure -C barfs with trailing spaces in CFLAGS
	CFLAGS="$RPM_OPT_FLAGS `pkg-config --cflags openssl | sed 's/ *$//'`"
	AP_LIBS="$AP_LIBS `pkg-config --libs openssl`"
else
	CFLAGS="$RPM_OPT_FLAGS"
	AP_LIBS="-lssl -lcrypto"
fi
export CFLAGS
export AP_LIBS

function mpmbuild() 
{
mpm=$1; shift
mkdir $mpm; pushd $mpm
cat > config.cache <<EOF
ac_cv_func_pthread_mutexattr_setpshared=no
ac_cv_func_sem_open=no
EOF
  ../configure 	-C \
		--prefix=%{_sysconfdir}/httpd \
 		--exec-prefix=%{_prefix} \
	 	--bindir=%{_bindir} \
	 	--sbindir=%{_sbindir} \
	 	--mandir=%{_mandir} \
		--libdir=%{_libdir} \
		--sysconfdir=%{_sysconfdir}/httpd/conf \
		--includedir=%{_includedir}/httpd \
		--libexecdir=%{_libdir}/httpd/modules \
		--datadir=%{contentdir} \
		--with-mpm=$mpm \
		--with-apr=%{_prefix} \
		--with-apr-util=%{_prefix} \
		--enable-suexec \
		--with-suexec \
		--with-suexec-caller=%{suexec_caller} \
		--with-suexec-docroot=%{suexec_dir} \
		--with-suexec-logfile=%{_localstatedir}/log/httpd/suexec.log \
		--with-suexec-bin=%{_sbindir}/suexec \
		--with-suexec-uidmin=500 \
		--with-suexec-gidmin=500 \
	        --with-devrandom=/dev/urandom \
		--with-ssl \
		--enable-ssl \
        	--enable-cache \
		--enable-disk-cache \
		--enable-file-cache \
		--enable-ldap \
	        --enable-authnz-ldap \
		--enable-mem-cache \
		--enable-deflate \
		--enable-cgid \
		--enable-proxy \
		--enable-authn-anon \
		--enable-authn-alias \
		--enable-proxy-connect \
		--enable-proxy-http \
		--enable-proxy-ftp \
		$*

  %{__make} %{?_smp_mflags}
  popd
}

# Only bother enabling optional modules for main build.
mpmbuild prefork --enable-mods-shared=all

# To prevent most modules being built statically into httpd.worker, 
# easiest way seems to be enable them shared.

# CLWELLS - LATER
#mpmbuild worker --enable-mods-shared=all

# Verify that the same modules were built into the two httpd binaries

# CLWELLS - LATER
#./prefork/httpd -l | grep -v prefork > prefork.mods
#./worker/httpd -l | grep -v worker > worker.mods
#if ! diff -u prefork.mods worker.mods; then
#  : Different modules built into httpd binaries, will not proceed
#  exit 1
#fi

%install

rm -rf %{buildroot}

# Classify ab and logresolve as section 1 commands, as they are in /usr/bin
mv docs/man/ab.8 docs/man/ab.1
sed -e "1s/logresolve 8/logresolve 1/" \
  < docs/man/logresolve.8 > docs/man/logresolve.1
rm docs/man/logresolve.8

pushd prefork
%{__make}                                                \
	DESTDIR=%{buildroot}                             \
	install
popd

# install worker binary
# CLWELLS - LATER
#install -m 755 worker/.libs/httpd %{buildroot}%{_sbindir}/httpd.worker

# install httpd.conf
%ifarch i386
	install -m0644 \
	%{SOURCE10} %{buildroot}%{_sysconfdir}/httpd/conf/httpd.conf
%elseifarch x86_64
	install -m0644 \
	%{SOURCE11} %{buildroot}%{_sysconfdir}/httpd/conf/httpd.conf
%endif

# mod_ssl bits
mkdir -p -m 0755 %{buildroot}%{_sysconfdir}/httpd/conf.d
for suffix in crl crt csr key prm; do
   mkdir %{buildroot}%{_sysconfdir}/httpd/conf/ssl.${suffix}
done

# fix where ssl.conf is
rm -f %{buildroot}%{_sysconfdir}/httpd/conf/ssl.conf
cp %{SOURCE2} %{buildroot}%{_sysconfdir}/httpd/conf.d/ssl.conf

# Makefiles for certificate management
#for ext in crt crl; do 
#  install -m 644 ./build/rpm/mod_ssl-Makefile.${ext} \
#	%{buildroot}%{_sysconfdir}/httpd/conf/ssl.${ext}/Makefile.${ext}
#done
#ln -s ../../../usr/share/ssl/certs/Makefile %{buildroot}/etc/httpd/conf

# for holding mod_dav lock database
mkdir -p %{buildroot}%{_localstatedir}/lib/dav

# create a prototype session cache
mkdir -p %{buildroot}%{_localstatedir}/cache/mod_ssl
touch %{buildroot}%{_localstatedir}/cache/mod_ssl/scache.{dir,pag,sem}

# move utilities to /usr/bin
mv %{buildroot}%{_sbindir}/{ab,htdbm,logresolve,htpasswd,htdigest} \
   %{buildroot}%{_bindir}

# move builddir to the right place
mv %{buildroot}%{contentdir}/build %{buildroot}%{_libdir}/httpd/build

# point to the correct libtool
apr_libtool=`apr-config --apr-libtool | sed -e 's|/bin/sh ||'`
echo `pwd`
ln -s ../../../../..${apr_libtool} %{buildroot}%{_libdir}/httpd/build/libtool

# Install and sanitize config_vars file: relocate the build directory into
# libdir; reference correct libtool; fix EXTRA_INCLUDES
sed -e "s|%{contentdir}/build|%{_libdir}/httpd/build|g" \
    -e "/AP_LIBS/d" -e "/abs_srcdir/d" \
    -e "/^LIBTOOL/s|/bin/sh /[^ ]*/libtool|/bin/sh ${apr_libtool}|" \
    -e "/^installbuilddir/s| = .*$| = /etc/httpd/build|" \
    -e "s|^EXTRA_INCLUDES.*$|EXTRA_INCLUDES = -I\$(includedir) -I\$(APR_INCLUDEDIR) -I%{_includedir}/openssl|g" \
  < prefork/build/config_vars.mk \
  > %{buildroot}%{_libdir}/httpd/build/config_vars.mk
install -m 644 build/special.mk \
    %{buildroot}%{_libdir}/httpd/build/special.mk

# Make the MMN accessible to module packages
echo %{mmn} > %{buildroot}%{_includedir}/httpd/.mmn

# docroot
rm -r %{buildroot}%{contentdir}/manual/style
#rm %{buildroot}%{contentdir}/manual/*/*.xml

# logs
rmdir %{buildroot}%{_sysconfdir}/httpd/logs
mkdir -p %{buildroot}%{_localstatedir}/log/httpd

# symlinks for /etc/httpd
ln -s ../..%{_localstatedir}/log/httpd %{buildroot}/etc/httpd/logs
ln -s ../..%{_localstatedir}/run %{buildroot}/etc/httpd/run
ln -s ../..%{_libdir}/httpd/modules %{buildroot}/etc/httpd/modules
ln -s ../..%{_libdir}/httpd/build %{buildroot}/etc/httpd/build

# install SYSV init stuff
mkdir -p %{buildroot}/etc/rc.d/init.d
install -m700 %{SOURCE3} \
	%{buildroot}/etc/rc.d/init.d/httpd
%{__perl} -pi -e "s:\@docdir\@:%{_docdir}/%{name}-%{version}:g" \
	%{buildroot}/etc/rc.d/init.d/httpd	

# install log rotation stuff
mkdir -p %{buildroot}/etc/logrotate.d
install -m644 ./build/rpm/httpd.logrotate \
	%{buildroot}/etc/logrotate.d/httpd

# Remove unpackaged files
# Remove unpackaged files
rm -f %{buildroot}%{_libdir}/*.exp \
      %{buildroot}%{_libdir}/httpd/modules/*.exp \
      %{buildroot}%{contentdir}/htdocs/* \
      %{buildroot}%{contentdir}/cgi-bin/* \
      %{buildroot}%{_mandir}/man1/dbmmanage.*

# move our test page into place
mkdir %{buildroot}%{contentdir}/html
cp %{SOURCE4} %{buildroot}%{contentdir}/html/index.php
cp %{SOURCE5} %{buildroot}%{contentdir}/html/apache_pb.gif
cp %{SOURCE6} %{buildroot}%{contentdir}/html/iworx_pb.gif
cp %{SOURCE7} %{buildroot}%{contentdir}/html/openssl_pb.gif
cp %{SOURCE8} %{buildroot}%{contentdir}/html/php_pb.png
cp %{SOURCE9} %{buildroot}%{contentdir}/html/interworx_logo.gif

%pre
# Add the "apache" user
useradd -c "Apache server" -u 80 \
	-s /sbin/nologin -r -d %{contentdir} apache 2> /dev/null || :

%triggerpostun -- apache < 2.0
if [ -x /sbin/chkconfig ]; then
	/sbin/chkconfig --add httpd
fi

%post

# Register the httpd service but only if we're a new install.  We're
# doing this because there are users who aren't running apache httpd
# as their main webserver), and we don't want it to be added to
# chkconfig unless it's a fresh install.

if [ $1 -eq 1 ] && [ -x /sbin/chkconfig ] ; then
	/sbin/chkconfig --add httpd
	/sbin/chkconfig --level 345 httpd on
fi

# Only restart httpd if it's already running.

if [ -x /sbin/service ]; then
	httpd -t

	# If the syntax is okay, then try to restart httpd.

	if [ "$?" -eq "0" ]; then
		/sbin/service httpd condrestart || :
	fi
fi

# apache default htdocs compat
if [ ! -a %{contentdir}/htdocs ]; then
	ln -fs %{contentdir}/html %{contentdir}/htdocs
fi

%preun

#
# if we're erasing
if [ "$1" = "0" ]; then
	if [ -x /sbin/service ]; then
		/sbin/service httpd stop > /dev/null 2>&1
	fi

	if [ -x /sbin/chkconfig ]; then
		/sbin/chkconfig --del httpd
	fi
fi

%post -n mod_ssl
/sbin/ldconfig ### is this needed?
umask 077

if [ ! -f %{_sysconfdir}/httpd/conf/ssl.key/server.key ] ; then
	%{_bindir}/openssl genrsa -rand /proc/apm:/proc/cpuinfo:/proc/dma:/proc/filesystems:/proc/interrupts:/proc/ioports:/proc/pci:/proc/rtc:/proc/uptime 1024 > %{_sysconfdir}/httpd/conf/ssl.key/server.key 2> /dev/null
fi

FQDN=`hostname`
if [ "x${FQDN}" = "x" ]; then
   FQDN=localhost.localdomain
fi

if [ ! -f %{_sysconfdir}/httpd/conf/ssl.crt/server.crt ] ; then
cat << EOF | %{_bindir}/openssl req -new -key %{_sysconfdir}/httpd/conf/ssl.key/server.key -x509 -days 365 -out %{_sysconfdir}/httpd/conf/ssl.crt/server.crt 2>/dev/null
--
SomeState
SomeCity
SomeOrganization
SomeOrganizationalUnit
${FQDN}
root@${FQDN}
EOF
fi

%clean
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}
[ -d $RPM_BUILD_DIR/%{name}-%{pversion} ] && rm -rf $RPM_BUILD_DIR/%{name}-%{pversion}

%files
%defattr(-,root,root)

%doc ABOUT_APACHE README CHANGES LICENSE

%dir %{_sysconfdir}/httpd
%{_sysconfdir}/httpd/modules
%{_sysconfdir}/httpd/logs
%{_sysconfdir}/httpd/run
%dir %{_sysconfdir}/httpd/conf
%config(noreplace) %{_sysconfdir}/httpd/conf/*.conf
%config(noreplace) %{_sysconfdir}/httpd/conf/magic
%config(noreplace) %{_sysconfdir}/httpd/conf/mime.types
%dir %{_sysconfdir}/httpd/conf.d
%dir %{_sysconfdir}/httpd/conf/extra/*.conf
%dir %{_sysconfdir}/httpd/conf/original/*.conf
%dir %{_sysconfdir}/httpd/conf/original/extra/*.conf

%config %{_sysconfdir}/logrotate.d/httpd
%config %{_sysconfdir}/rc.d/init.d/httpd

#%dir %{_sysconfdir}/httpd/conf

%{_bindir}/ab
%{_bindir}/ht*
%{_bindir}/logresolve
%{_sbindir}/httpd
%{_sbindir}/httxt2dbm
%{_sbindir}/htcacheclean
# CLWELLS - LATER
#%{_sbindir}/httpd.worker
%{_sbindir}/apachectl
%{_sbindir}/rotatelogs
%attr(4510,root,%{suexec_caller}) %{_sbindir}/suexec

%dir %{_libdir}/httpd
%dir %{_libdir}/httpd/modules
# everything but mod_ssl.so:
%{_libdir}/httpd/modules/mod_[a-r]*.so
%{_libdir}/httpd/modules/mod_s[petu]*.so
%{_libdir}/httpd/modules/mod_[t-z]*.so

%dir %{contentdir}
%dir %{contentdir}/html
%dir %{contentdir}/icons
%dir %{contentdir}/error
%dir %{contentdir}/error/include
%dir %{contentdir}/error/README
%{contentdir}/icons/*
%{contentdir}/html/*
%config(noreplace) %{contentdir}/error/*.var
%config(noreplace) %{contentdir}/error/include/*.html

%attr(0711,root,root) %dir %{_localstatedir}/log/httpd

%attr(0700,apache,apache) %dir %{_localstatedir}/lib/dav

%{_mandir}/man1/*
%{_mandir}/man8/*

%files manual
%defattr(-,root,root)
%{contentdir}/manual

%files -n mod_ssl
%defattr(-,root,root)
%{_libdir}/httpd/modules/mod_ssl.so
%attr(0700,root,root) %dir %{_sysconfdir}/httpd/conf/ssl.*
%config(noreplace) %{_sysconfdir}/httpd/conf.d/ssl.conf
#%config %{_sysconfdir}/httpd/conf/Makefile
#%dir %{_sysconfdir}/httpd/conf/ssl.*
%attr(0700,apache,root) %dir %{_localstatedir}/cache/mod_ssl
%attr(0600,apache,root) %ghost %{_localstatedir}/cache/mod_ssl/scache.dir
%attr(0600,apache,root) %ghost %{_localstatedir}/cache/mod_ssl/scache.pag
%attr(0600,apache,root) %ghost %{_localstatedir}/cache/mod_ssl/scache.sem

%files devel
%defattr(-,root,root)
%{_includedir}/httpd
%{_sysconfdir}/httpd/build
%{_sbindir}/apxs
%{_sbindir}/checkgid
%{_sbindir}/dbmmanage
%{_sbindir}/envvars*
%{_mandir}/man8/apxs.8*
%dir %{_libdir}/httpd/build
%{_libdir}/httpd/build/*.mk
%{_libdir}/httpd/build/instdso.sh
%{_libdir}/httpd/build/libtool
%{_libdir}/httpd/build/config.nice
%{_libdir}/httpd/build/mkdir.sh

%changelog
* Mon Jun 27 2011 Paul Oehler <poehler@interworx.com>
- Changed the /var/www/html/index.php interworx splash text.
* Thu Oct 21 2010 Paul Oehler <poehler@interworx.com>
- Upgraded to 2.2.17
* Tue Aug 31 2010 Jon Daniel <jdaniel@interworx.com>
- Fixed RPM so it won't start httpd if it's not currently running,
  and it won't be added to chkconfig unless it's a new install.  This
  was done because of bug no.1559 in the interworx bug tracker.
* Tue Aug 11 2010 Paul Oehler <poehler@interworx.com>
- Added mod_ldap, mod_authn_alias, mod_authnz_ldap, and mod_file_cache, 
  for compatiblity with utterramblings repo version.
- Added rhe6x support
* Tue Jun 17 2008 Paul Oehler <poehler@interworx.com>
- Updated for Fedora 9
* Tue May 13 2008 Paul Oehler <poehler@interworx.com>
- Added support for Fedora 8
* Wed May 23 2007 Chris Wells <clwells@nexcess.net>
- Rebuilt for rhe5x / Apache 2.2.4
* Mon Aug 15 2005 Chris Wells <clwells@nexcess.net>
- Added ulimit to httpd init.d to bump up file handles
* Sun Sep 5 2004 Chris Wells <clwells@nexcess.net>
- Added '-DSSL' as a startup option in the init.d script
  it was missing :( and SSL no worky
- Changed ServerTokens to 'OS' from 'FULL' in the httpd.conf
- bumped to 101 release
* Tue Jun 28 2004 Chris Wells <clwells@nexcess.net>
- Initial packaging as part of InterWorx-HAL OS

